library(plyr)
set.seed(12321)
input <- readLines("broken.par")
prob <- as.double(input[2])
# 1 = geometric, 0 = counter
randombr <- as.integer(input[4])
ldmaxlength <- as.integer(input[5])
if (file.access("listdag.Rdata")==-1)
{
    dag <- read.table(input[1],header=T)
    nodesums <- function(df)
    {
        df$prob <- df$Count/sum(df$Count)
        df
    }
    mysplit <- function(df)
    {
        ddply(df,.(Parent),nodesums)
    }
    listdag <- dlply(dag,.(Level),mysplit)
    save(listdag,file="listdag.Rdata")
} else
{
    load("listdag.Rdata")
}

doahap <- function()
{
    thehap <- numeric(length(listdag))
    parent <- 0
    counter <- 1
    ldcounter <- 0
    mycounter = 0
    for (i in listdag)
    {
        parentrow <- match(parent,i$Parent)
        chosenrow <- parentrow + (runif(1) > i$prob[parentrow])
        thehap[counter] <- i$Allele[chosenrow]
        if (!randombr && length(i$Child)==2)  ldcounter <- 0
        if ((randombr && runif(1)<prob) | (!randombr && ldcounter >= ldmaxlength))
        {
            #            parent <- sample(0:max(i$Child),1)
            #        } else if 
            #        {
            tmp <- sample.int(sum(i$Count),1)
            sums <- cumsum(i$Count)
            parent <- (i$Child[sum(tmp>sums)+1])
            ldcounter <- 0
        } else
        {
            parent <- i$Child[chosenrow]
        }
        counter <- counter + 1
        ldcounter <- ldcounter + 1
    }
    return(thehap)

}

out <- replicate(20,doahap())
write.table(out,file=input[3],sep="",row.names=F,col.names=F)
